/*
	(C) 2011. Kruchinin Aleksandr. http://vidikon.com
	Management.cpp
	1.00
*/
#include "Management.h"

HANDLE Mutex;
HANDLE Mutex_Data_Generate1;
HANDLE Mutex_Control;
DWORD WINAPI M_Control(LPVOID);

int M_ControlTime=1000;
bool displayc=false;
bool recognize=false;

PCOPYDATASTRUCT cds1;
int OnCopyData(HWND hWnd,UINT wParam,LONG lParam);

#define MAX_RECOG_PROC		20			// Max recognition process
extern int ActiveProcess;
extern PROCESS_INFORMATION pi[MAX_RECOG_PROC];
extern void ReRunProcess(int num);

HANDLE Mutex_Recog[MAX_RECOG_PROC];

DWORD WINAPI M_Management(LPVOID)
{
	HINSTANCE hInstance=GetModuleHandle(NULL);
	WNDCLASS WndClass;    
    char ClassName[]="M_Management";
	HWND hWnd;
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
    WndClass.lpfnWndProc=M_Management_WIN32PROC;
    WndClass.cbClsExtra=0;
    WndClass.cbWndExtra=0;
    WndClass.hInstance=hInstance;
    WndClass.hIcon=NULL;
    WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
    WndClass.hbrBackground=(HBRUSH)GetStockObject(BLACK_BRUSH);;
    WndClass.lpszMenuName=NULL;
    WndClass.lpszClassName=ClassName;
    if (!RegisterClass(&WndClass))
	{
		MessageBox(NULL,"Cannot register class","Error",MB_OK | MB_ICONERROR);
		return 0;
	}
    hWnd=CreateWindowEx(0, ClassName,"Module Management",
                      WS_OVERLAPPEDWINDOW,
                      CW_USEDEFAULT,CW_USEDEFAULT,
                      400,80,
                      NULL,NULL,hInstance,NULL);
	if (hWnd==NULL)
	{		
		MessageBox(NULL,"Cannot create window","Error",MB_OK | MB_ICONERROR);
		return 0;
	} 
	ShowWindow(hWnd,1);
    UpdateWindow(hWnd);
	MSG msg; 
	
    while (1) { 
		Sleep(1);
        while (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE) == TRUE) 
        { 
            if (GetMessage(&msg, NULL, 0, 0) ) 
            { 
                TranslateMessage(&msg); 
                DispatchMessage(&msg); 
            } else { 
                return TRUE; 
            } 
        } 		
    } 
	
    return 0;
}

LRESULT CALLBACK M_Management_WIN32PROC(HWND hWnd,UINT Message,
                           UINT wParam,LONG lParam)
{
	HANDLE h;
	switch(Message)
    {
	case WM_DESTROY:		
		PostQuitMessage(0);
		break;
	case WM_CREATE:				
		Sleep(10);		
		DWORD lpT;
		h=CreateThread(NULL,0,M_Control,NULL,0,&lpT);
		break;
	case WM_COPYDATA:
		OnCopyData(hWnd,wParam,lParam);
		break;
	}

	return DefWindowProc(hWnd,Message,wParam,lParam);
}


// Control Module
DWORD WINAPI M_Control(LPVOID)
{
	char buf[256];
	for(int i=0;i<MAX_RECOG_PROC;i++)
	{
		sprintf(buf,"Mutex_Recog_Run_%d",i+1);
		Mutex_Recog[i]=CreateMutex(NULL,true,buf);	
	}		
	// Wait Run
	Mutex=OpenMutex(SYNCHRONIZE,true,"Mutex_Management");
	WaitForSingleObject(Mutex,INFINITE);
	printf("Run Management module...\n");
	ReleaseMutex(Mutex_Recog[ActiveProcess]);
	HANDLE Mutex1;
	HANDLE Mutex2;
	long N;
	Sleep(1);
	Mutex2=CreateMutex(NULL,true,"Mutex_Data2");
	ReleaseMutex(Mutex2);
	do{			
		Mutex1=OpenMutex(SYNCHRONIZE,true,"Mutex_Control");
		WaitForSingleObject(Mutex1,INFINITE);
		ReleaseMutex(Mutex1);
		if (displayc) printf("Control\n");
		WaitForSingleObject(Mutex2,1);
		Sleep(M_ControlTime);	
		// Check for completeness of the task! End task, if necessary, switch to another process
		if (recognize)
		{
			if (displayc) printf("Recognition result %d\n",cds1->dwData);
			recognize=false;
		}
		else
		{
			// Remove the process and make another active process of recognition
			// It's a bit wrong, but done to test the model
			if (displayc) printf("Kill Process\n");
			if (pi[ActiveProcess].hProcess!=NULL) TerminateProcess(pi[ActiveProcess].hProcess,NO_ERROR);			
			// Disable the old process, which removed
			Mutex_Recog[ActiveProcess]=CreateMutex(NULL,true,buf);	
			ReRunProcess(ActiveProcess);
			//Run the procedure restarts the process
			// Allow a new process
			ActiveProcess++;
			ReleaseMutex(Mutex_Recog[ActiveProcess]);
		}
		// Permission to generate data
		ReleaseMutex(Mutex2);
	}while(1);
	return 0;
}

void SetM_ControlTime(int time)
{
	M_ControlTime=time;
}


int OnCopyData(HWND hWnd,UINT wParam,LONG lParam)
{	

	cds1=(PCOPYDATASTRUCT) lParam;		

	recognize=true;

	return 0;
}

void SetM_ControlDisplay()
{
	if (displayc==1) displayc=0;
	else displayc=1;
}