/*
	(C) 2011. Kruchinin Aleksandr. http://vidikon.com
	recognize.cpp
	1.00
*/
#include <windows.h>
#include <stdio.h>

#define MAX_SIZE	0x10000

LRESULT CALLBACK WIN32PROC(HWND hWnd,UINT Message,
                           UINT wParam,LONG lParam);
DWORD WINAPI M_Recognize(LPVOID);

int num; //ID process

HWND MainW;
HWND hWnd;

int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
                   LPSTR lpszCmdParam,int nCmdShow)
{
	WNDCLASS WndClass;    
    char ClassName[]="M_Recognize";	
	WndClass.style=CS_HREDRAW | CS_VREDRAW;
    WndClass.lpfnWndProc=WIN32PROC;
    WndClass.cbClsExtra=0;
    WndClass.cbWndExtra=0;
    WndClass.hInstance=hInstance;
    WndClass.hIcon=NULL;
    WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
    WndClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);;
    WndClass.lpszMenuName=NULL;
    WndClass.lpszClassName=ClassName;
    if (!RegisterClass(&WndClass))
	{
		MessageBox(NULL,"Cannot register class","Error",MB_OK | MB_ICONERROR);
		return 0;
	}

	char buf[256];
	int i=atoi(lpszCmdParam);
	num=i;

	wsprintf(buf,"Module Recognize #%d",i);

    hWnd=CreateWindowEx(0, ClassName,buf,
                      WS_OVERLAPPEDWINDOW,
                      CW_USEDEFAULT,CW_USEDEFAULT,
                      400,80,
                      NULL,NULL,hInstance,NULL);
	if (hWnd==NULL)
	{		
		MessageBox(NULL,"Cannot create window","Error",MB_OK | MB_ICONERROR);
		return 0;
	} 
	ShowWindow(hWnd,1);
    UpdateWindow(hWnd);
	MSG msg; 

	// Find main programm
	MainW=FindWindowEx(NULL,NULL,"M_Management",NULL);

    while (1) { 
		Sleep(1);
        while (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE) == TRUE) 
        { 
            if (GetMessage(&msg, NULL, 0, 0) ) 
            { 
                TranslateMessage(&msg); 
                DispatchMessage(&msg); 
            } else { 
                return TRUE; 
            } 
        } 
   
    } 
	return msg.wParam;
}

LRESULT CALLBACK WIN32PROC(HWND hWnd,UINT Message,
                           UINT wParam,LONG lParam)
{
	switch(Message)
    {
	case WM_DESTROY:		
		PostQuitMessage(0);
		break;
	case WM_CREATE:		
		DWORD lpT;
		Sleep(10);
		HANDLE h=CreateThread(NULL,0,M_Recognize,NULL,0,&lpT);					
		break;
	}

	return DefWindowProc(hWnd,Message,wParam,lParam);
}


// Recognize Module
DWORD WINAPI M_Recognize(LPVOID)
{	
	HANDLE Mutex_Recog_D;	
	HANDLE Mutex_Control_D;
	long N;
	long N1;

	COPYDATASTRUCT cds;
	char buf[256];
		
	Sleep(1000);
	sprintf(buf,"Mutex_Recog_Run_%d",num);		
	HANDLE M=OpenMutex(SYNCHRONIZE,true,buf);		
	WaitForSingleObject(M,INFINITE);		
	//if (num!=1) MessageBox(NULL,"1",buf,MB_OK);
			

	HANDLE hMapping;
	char* lpData;
	hMapping = OpenFileMapping( FILE_MAP_READ, false, "M_Data_Page");
	if (hMapping == NULL) return 1;

	// Placing the projection hMapping in the address space of our process, lpData gets the address location
	lpData = (char*) MapViewOfFile(hMapping, FILE_MAP_READ,0,0,0);
	if (lpData == NULL) return 1;
	
	unsigned long i;	
	int j=0;
	do{							
		Mutex_Recog_D=OpenMutex(SYNCHRONIZE,true,"Mutex_Recog_D");			
		WaitForSingleObject(Mutex_Recog_D,INFINITE);
		ReleaseMutex(Mutex_Recog_D);
		// Recognize data
		for(i=0;i<MAX_SIZE;i++)
			if (lpData[i]==1) break;
		if (j==30 && num==1) Sleep(5000);
		// Now only post message
		cds.dwData=i;
		cds.cbData=0;
		cds.lpData=NULL;
		SendMessage(MainW,WM_COPYDATA,(WPARAM) hWnd, (LPARAM) &cds);										
		Mutex_Control_D=OpenMutex(SYNCHRONIZE,true,"Mutex_Control_D");						
		WaitForSingleObject(Mutex_Control_D,INFINITE);			
		ReleaseMutex(Mutex_Control_D);
		j++;
	}while(1);

	UnmapViewOfFile( ( LPCVOID )lpData );
	CloseHandle( hMapping );
	return 0;
}